import { computed as m, openBlock as l, createElementBlock as s, normalizeClass as x, createElementVNode as r, toDisplayString as d, createCommentVNode as c, renderSlot as h, ref as V, createVNode as N, withCtx as $, useSlots as O, unref as q, resolveComponent as z, Fragment as C, renderList as B, createBlock as k, createTextVNode as A, inject as U, withDirectives as F, vModelDynamic as P, provide as H, watch as K, resolveDynamicComponent as M, normalizeStyle as Y, vModelCheckbox as E, onMounted as Z, withKeys as R, withModifiers as D, vModelSelect as ee } from "vue";
import te from "fuse.js";
import { getProperty as j } from "dot-prop";
import { RouterLink as I, useRoute as le } from "vue-router";
const se = { key: 0 }, oe = { class: "cf-action-card__body" }, ne = { class: "cf-action-card__action" }, Al = {
  __name: "ActionCard",
  props: {
    title: String,
    simple: Boolean
  },
  setup(a) {
    const t = a, e = m(() => ({
      "cf-action-card": !0,
      "cf-action-card--simple": t.simple
    }));
    return (n, o) => (l(), s("div", {
      class: x(e.value)
    }, [
      r("div", null, [
        t.title ? (l(), s("h5", se, d(t.title), 1)) : c("", !0),
        r("div", oe, [
          h(n.$slots, "body")
        ])
      ]),
      r("div", ne, [
        h(n.$slots, "action")
      ])
    ], 2));
  }
};
const G = (a, t) => {
  const e = a.__vccOpts || a;
  for (const [n, o] of t)
    e[n] = o;
  return e;
}, ae = {}, re = { class: "cf-app-bar" };
function ue(a, t) {
  return l(), s("header", re, [
    r("div", null, [
      h(a.$slots, "left")
    ]),
    r("div", null, [
      h(a.$slots, "right")
    ])
  ]);
}
const ie = /* @__PURE__ */ G(ae, [["render", ue]]);
const de = { class: "cf-dropdown-body" }, ce = {
  __name: "Dropdown",
  setup(a) {
    const t = V(!1), e = m(() => ({
      "cf-dropdown": !0,
      "cf-dropdown--open": t.value
    }));
    return (n, o) => (l(), s("div", {
      class: x(e.value)
    }, [
      r("div", {
        class: "cf-dropdown-toggle",
        onClick: o[0] || (o[0] = (u) => t.value = !t.value)
      }, [
        h(n.$slots, "toggle")
      ]),
      r("div", de, [
        h(n.$slots, "body")
      ]),
      r("div", {
        class: "cf-dropdown-backdrop",
        onClick: o[1] || (o[1] = (u) => t.value = !1)
      })
    ], 2));
  }
};
const _e = {
  key: 0,
  class: "cf-app-bar-link"
}, pe = { class: "cf-app-bar-link__label" }, fe = /* @__PURE__ */ r("svg", {
  xmlns: "http://www.w3.org/2000/svg",
  viewBox: "0 0 16 16",
  width: "16"
}, [
  /* @__PURE__ */ r("path", { d: "M14.15 4.492H1.85l-.354.854 6.15 6.15h.707l6.15-6.15-.353-.854z" })
], -1), ve = {
  key: 1,
  class: "cf-app-bar-link"
}, me = { class: "cf-app-bar-link__label" }, Ll = {
  __name: "AppBarLink",
  props: {
    dropdown: Boolean
  },
  setup(a) {
    return (t, e) => a.dropdown ? (l(), s("div", _e, [
      N(ce, null, {
        toggle: $(() => [
          r("div", pe, [
            h(t.$slots, "default"),
            fe
          ])
        ]),
        body: $(() => [
          h(t.$slots, "dropdown")
        ]),
        _: 3
      })
    ])) : (l(), s("button", ve, [
      r("div", me, [
        h(t.$slots, "default")
      ])
    ]));
  }
};
const Tl = {
  __name: "AppView",
  props: { wide: Boolean },
  setup(a) {
    const t = a, e = m(() => ({
      "cf-app-view": !0,
      "cf-app-view--wide": t.wide
    }));
    return (n, o) => (l(), s("div", {
      class: x(e.value)
    }, [
      h(n.$slots, "default")
    ], 2));
  }
};
const he = { class: "cf-app-view-header" }, be = { key: 0 }, ye = { key: 1 }, ge = { key: 2 }, $e = {
  key: 3,
  class: "cf-app-view-header__actions"
}, ql = {
  __name: "AppViewHeader",
  props: {
    surtitle: String,
    title: String,
    description: String
  },
  setup(a) {
    const t = a, e = O();
    return (n, o) => (l(), s("header", he, [
      t.surtitle ? (l(), s("p", be, d(t.surtitle), 1)) : c("", !0),
      t.title ? (l(), s("h1", ye, d(t.title), 1)) : c("", !0),
      t.description ? (l(), s("p", ge, d(t.description), 1)) : c("", !0),
      q(e).actions ? (l(), s("div", $e, [
        h(n.$slots, "actions")
      ])) : c("", !0)
    ]));
  }
};
const Dl = {
  __name: "Banner",
  props: {
    type: String
  },
  setup(a) {
    const t = a, e = m(() => ({
      "cf-banner": !0,
      [`cf-banner--${t.type}`]: t.type
    }));
    return (n, o) => (l(), s("div", {
      class: x(e.value)
    }, [
      h(n.$slots, "default")
    ], 2));
  }
};
const ke = { class: "cf-breadcrumbs" }, Se = { key: 0 }, Nl = {
  __name: "Breadcrumbs",
  props: { data: Array },
  setup(a) {
    const t = a;
    return (e, n) => {
      const o = z("RouterLink");
      return l(), s("ol", ke, [
        (l(!0), s(C, null, B(t.data, (u) => (l(), s("li", {
          key: u.name
        }, [
          u.path ? (l(), k(o, {
            key: 1,
            to: u.path
          }, {
            default: $(() => [
              A(d(u.name), 1)
            ]),
            _: 2
          }, 1032, ["to"])) : (l(), s("span", Se, d(u.name), 1))
        ]))), 128))
      ]);
    };
  }
}, W = {
  to: {
    type: [String, Object],
    default: null
  },
  type: {
    type: String,
    default: "button"
  },
  large: Boolean,
  wide: Boolean,
  color: {
    type: String,
    default: null
  },
  loading: Boolean,
  disabled: Boolean
};
const xe = ["type", "disabled"], Ml = {
  __name: "FilledButton",
  props: W,
  setup(a) {
    const t = a, e = m(() => ({
      "cf-button": !0,
      "cf-button--large": t.large,
      "cf-button--wide": t.wide,
      "cf-button--loading": t.loading,
      "cf-button--disabled": t.disabled,
      "cf-filled-button": !0,
      [`cf-filled-button--${t.color}`]: t.color
    }));
    return (n, o) => {
      const u = z("router-link");
      return n.to ? (l(), k(u, {
        key: 0,
        class: x(e.value),
        to: n.to,
        inert: t.disabled
      }, {
        default: $(() => [
          h(n.$slots, "default")
        ]),
        _: 3
      }, 8, ["class", "to", "inert"])) : (l(), s("button", {
        key: 1,
        class: x(e.value),
        type: t.type,
        disabled: t.disabled
      }, [
        h(n.$slots, "default")
      ], 10, xe));
    };
  }
};
const we = ["type", "disabled"], Ce = {
  __name: "OutlinedButton",
  props: W,
  setup(a) {
    const t = a, e = m(() => ({
      "cf-button": !0,
      "cf-button--large": t.large,
      "cf-button--wide": t.wide,
      "cf-button--loading": t.loading,
      "cf-button--disabled": t.disabled,
      "cf-outlined-button": !0,
      [`cf-outlined-button--${t.color}`]: t.color
    }));
    return (n, o) => {
      const u = z("router-link");
      return n.to ? (l(), k(u, {
        key: 0,
        class: x(e.value),
        to: n.to,
        inert: t.disabled
      }, {
        default: $(() => [
          h(n.$slots, "default")
        ]),
        _: 3
      }, 8, ["class", "to", "inert"])) : (l(), s("button", {
        key: 1,
        class: x(e.value),
        type: t.type,
        disabled: t.disabled
      }, [
        h(n.$slots, "default")
      ], 10, we));
    };
  }
};
const Ve = ["disabled"], zl = {
  __name: "TextButton",
  props: {
    to: String,
    disabled: Boolean
  },
  setup(a) {
    const t = a;
    return (e, n) => {
      const o = z("router-link");
      return a.to ? (l(), k(o, {
        key: 0,
        class: "cf-text-button",
        to: a.to,
        inert: t.disabled
      }, {
        default: $(() => [
          h(e.$slots, "default")
        ]),
        _: 3
      }, 8, ["to", "inert"])) : (l(), s("button", {
        key: 1,
        class: "cf-text-button",
        type: "button",
        disabled: t.disabled
      }, [
        h(e.$slots, "default")
      ], 8, Ve));
    };
  }
};
const Be = { class: "cf-choice" }, Ae = ["type", "id", "name", "value", "true-value", "false-value", "required", "disabled"], Le = ["for"], Te = { key: 1 }, qe = {
  __name: "Choice",
  props: {
    modelValue: [Number, String, Boolean, Object, Array],
    value: [Number, String, Boolean, Object],
    trueValue: {
      type: [Number, String, Boolean],
      default: !0
    },
    falseValue: {
      type: [Number, String, Boolean],
      default: !1
    },
    type: String,
    label: [String, Boolean],
    helper: String,
    disabled: Boolean
  },
  emits: ["update:modelValue"],
  setup(a, { emit: t }) {
    const e = a, n = Math.random(), o = {
      name: U("choice-list-name", null),
      required: U("choice-list-required", null)
    }, u = m({
      get() {
        return e.modelValue;
      },
      set(i) {
        t("update:modelValue", i);
      }
    });
    return (i, f) => (l(), s("div", Be, [
      F(r("input", {
        "onUpdate:modelValue": f[0] || (f[0] = (b) => u.value = b),
        type: e.type,
        id: q(n),
        name: o.name,
        value: e.value,
        "true-value": e.trueValue,
        "false-value": e.falseValue,
        required: o.required,
        disabled: e.disabled
      }, null, 8, Ae), [
        [P, u.value]
      ]),
      a.label ? (l(), s("label", {
        key: 0,
        for: q(n)
      }, d(e.label || e.value), 9, Le)) : c("", !0),
      e.helper ? (l(), s("small", Te, d(e.helper), 1)) : c("", !0)
    ]));
  }
};
const De = {
  key: 0,
  class: "cf-choice-list__label"
}, Fl = {
  __name: "ChoiceList",
  props: {
    modelValue: [Number, String, Boolean, Array],
    label: String,
    choices: Array,
    multiple: Boolean,
    required: Boolean,
    disabled: Boolean
  },
  emits: ["update:modelValue"],
  setup(a, { emit: t }) {
    const e = a, n = m(() => ({
      "cf-choice-list": !0,
      "cf-choice-list--disabled": e.disabled
    })), o = m({
      get() {
        return e.modelValue;
      },
      set(u) {
        t("update:modelValue", u);
      }
    });
    return H("choice-list-name", Math.random()), H("choice-list-required", e.required), (u, i) => (l(), s("div", {
      class: x(n.value)
    }, [
      e.label ? (l(), s("div", De, d(e.label), 1)) : c("", !0),
      (l(!0), s(C, null, B(a.choices, (f) => (l(), k(qe, {
        key: f.value || f,
        type: e.multiple ? "checkbox" : "radio",
        label: f.label || f.value || f,
        helper: f.helper,
        value: f.value || f,
        disabled: e.disabled,
        modelValue: o.value,
        "onUpdate:modelValue": i[0] || (i[0] = (b) => o.value = b)
      }, null, 8, ["type", "label", "helper", "value", "disabled", "modelValue"]))), 128)),
      h(u.$slots, "default")
    ], 2));
  }
};
function T(a) {
  return typeof a == "function" ? a() : q(a);
}
function Ne(a, t, e) {
  const n = () => {
    var i, f;
    return new te(
      (i = T(t)) != null ? i : [],
      (f = T(e)) == null ? void 0 : f.fuseOptions
    );
  }, o = V(n());
  K(
    () => {
      var i;
      return (i = T(e)) == null ? void 0 : i.fuseOptions;
    },
    () => {
      o.value = n();
    },
    { deep: !0 }
  ), K(
    () => T(t),
    (i) => {
      o.value.setCollection(i);
    },
    { deep: !0 }
  );
  const u = m(() => {
    const i = T(e);
    if (i != null && i.matchAllWhenSearchEmpty && !T(a))
      return T(t).map((b, w) => ({ item: b, refIndex: w }));
    const f = i == null ? void 0 : i.resultLimit;
    return o.value.search(T(a), f ? { limit: f } : void 0);
  });
  return {
    fuse: o,
    results: u
  };
}
const X = {
  modelValue: [Number, String, Object],
  value: [Number, String, Object],
  label: String,
  disabled: Boolean,
  required: Boolean,
  helper: String,
  title: String,
  autofocus: Boolean
};
const Me = { class: "cf-form-control" }, ze = { key: 0 }, Fe = { class: "cf-form-control-widget" }, Oe = { key: 0 }, Re = ["disabled", "required", "type", "placeholder", "list", "step", "max", "min", "maxlength", "minlength", "pattern", "title", "autofocus"], je = { key: 1 }, Ie = { key: 1 }, J = {
  __name: "Input",
  props: {
    type: {
      type: String,
      default: "text"
    },
    placeholder: String,
    prefix: String,
    suffix: String,
    list: String,
    step: [Number, String],
    max: [Number, String],
    min: [Number, String],
    maxlength: [Number, String],
    minlength: [Number, String],
    pattern: String,
    ...X
  },
  emits: ["update:modelValue"],
  setup(a, { emit: t }) {
    const e = a, n = V(!1), o = m(() => e.type.toLowerCase() === "password" ? n.value ? "text" : "password" : e.type), u = m({
      get: () => e.modelValue || e.value,
      set: (i) => t("update:modelValue", i)
    });
    return (i, f) => (l(), s("div", Me, [
      e.label ? (l(), s("label", ze, [
        A(d(e.label) + " ", 1),
        e.type.toLowerCase() === "password" ? (l(), s("button", {
          key: 0,
          type: "button",
          tabindex: "-1",
          onClick: f[0] || (f[0] = (b) => n.value = !n.value)
        }, d(n.value ? "Hide" : "Show"), 1)) : c("", !0)
      ])) : c("", !0),
      r("div", Fe, [
        e.prefix ? (l(), s("div", Oe, d(e.prefix), 1)) : c("", !0),
        F(r("input", {
          "onUpdate:modelValue": f[1] || (f[1] = (b) => u.value = b),
          disabled: e.disabled,
          required: e.required,
          type: o.value,
          placeholder: e.placeholder,
          list: e.list,
          step: e.step,
          max: e.max,
          min: e.min,
          maxlength: e.maxlength,
          minlength: e.minlength,
          pattern: e.pattern,
          title: e.title,
          autofocus: e.autofocus
        }, null, 8, Re), [
          [P, u.value]
        ]),
        e.suffix ? (l(), s("div", je, d(e.suffix), 1)) : c("", !0)
      ]),
      e.helper ? (l(), s("small", Ie, d(e.helper), 1)) : c("", !0)
    ]));
  }
};
const Ue = {
  key: 0,
  class: "cf-data-table-title"
}, He = {
  key: 1,
  class: "cf-data-table-description"
}, Ke = {
  key: 2,
  class: "cf-data-table-search"
}, Pe = {
  key: 3,
  class: "cf-data-table-action"
}, Ee = {
  __name: "DataTableHeader",
  props: {
    title: String,
    description: String,
    searchable: Boolean,
    search: String
  },
  emits: ["update:search"],
  setup(a, { emit: t }) {
    const e = a, n = O(), o = m({
      get: () => e.search,
      set: (u) => t("update:search", u)
    });
    return (u, i) => (l(), s("header", null, [
      e.title ? (l(), s("div", Ue, d(e.title), 1)) : c("", !0),
      e.description ? (l(), s("div", He, d(e.description), 1)) : c("", !0),
      e.searchable ? (l(), s("div", Ke, [
        N(J, {
          modelValue: o.value,
          "onUpdate:modelValue": i[0] || (i[0] = (f) => o.value = f),
          label: "Search"
        }, null, 8, ["modelValue"])
      ])) : c("", !0),
      q(n).default ? (l(), s("div", Pe, [
        h(u.$slots, "default")
      ])) : c("", !0)
    ]));
  }
}, Ze = {
  key: 0,
  "data-table-checkbox": ""
}, Ge = ["value", "checked", "disabled"], We = {
  key: 1,
  "data-table-row-actions": ""
}, Xe = { key: 0 }, Je = {
  __name: "DataTableRow",
  props: {
    data: Object,
    columns: Array,
    forceMenu: Boolean,
    includeCheckbox: Boolean
  },
  emits: ["toggle", "action"],
  setup(a, { emit: t }) {
    const e = a, n = m(() => e.data._), o = m(() => e.data.data), u = m(() => e.forceMenu || n.value.actions.length > 1), i = m(() => n.value.actions.map((b) => {
      const w = b.name || b, p = b.key || w.toUpperCase().replaceAll(" ", "_"), _ = () => t("action", { key: p, data: o.value });
      let S = "span";
      return b.to && (S = I), b.href && (S = "a"), {
        label: w,
        to: b.to,
        href: b.href,
        key: p,
        invoke: _,
        component: S
      };
    })), f = m(() => {
      const b = {
        component: "span",
        label: "•••",
        invoke: null
      };
      return u.value ? b : i.value[0];
    });
    return (b, w) => (l(), s("tr", null, [
      e.includeCheckbox ? (l(), s("td", Ze, [
        r("input", {
          type: "checkbox",
          value: o.value.id,
          checked: n.value.isSelected,
          disabled: !n.value.isSelectable,
          onChange: w[0] || (w[0] = (p) => t("toggle"))
        }, null, 40, Ge)
      ])) : c("", !0),
      h(b.$slots, "default", {}, () => [
        (l(!0), s(C, null, B(e.columns, (p) => {
          var _;
          return l(), s("td", {
            key: p.key
          }, d((_ = q(j)(o.value, p.key)) == null ? void 0 : _.toLocaleString()), 1);
        }), 128))
      ]),
      n.value.actions ? (l(), s("td", We, [
        r("button", null, [
          (l(), k(M(f.value.component), {
            to: f.value.to,
            href: f.value.href,
            onClick: f.value.invoke
          }, {
            default: $(() => [
              A(d(f.value.label), 1)
            ]),
            _: 1
          }, 8, ["to", "href", "onClick"]))
        ]),
        u.value ? (l(), s("div", Xe, [
          (l(!0), s(C, null, B(i.value, (p) => (l(), s("button", {
            key: p.key
          }, [
            (l(), k(M(p.component), {
              to: p.to,
              href: p.href,
              onClick: p.invoke
            }, {
              default: $(() => [
                A(d(p.label), 1)
              ]),
              _: 2
            }, 1032, ["to", "href", "onClick"]))
          ]))), 128))
        ])) : c("", !0)
      ])) : c("", !0)
    ]));
  }
};
const Qe = { class: "cf-data-table" }, Ye = { class: "cf-data-table-container" }, et = {
  key: 0,
  style: { "--w": "3rem" }
}, tt = {
  key: 1,
  style: { "--w": "4rem" }
}, lt = {
  key: 0,
  "data-table-checkbox": ""
}, st = ["disabled"], ot = ["onClick"], nt = { key: 1 }, at = { key: 1 }, Ol = {
  __name: "DataTable",
  props: {
    title: String,
    description: String,
    data: {
      type: Array,
      default: () => []
    },
    columns: {
      type: Array,
      default: () => []
    },
    selection: {
      type: Array,
      default: []
    },
    rowActions: [Boolean, Array],
    forceRowMenu: Boolean,
    customTemplate: Boolean,
    selectable: Boolean,
    sortable: Boolean,
    defaultSortKey: {
      type: String,
      default: ""
    },
    searchable: Boolean
  },
  emits: ["update:selection", "row-action"],
  setup(a, { emit: t }) {
    const e = a, n = O(), o = V(e.defaultSortKey), u = V("asc"), i = V(""), f = m(() => {
      if (e.searchable) {
        const { results: v } = Ne(i, e.data, {
          fuseOptions: {
            keys: e.columns.map(({ key: g }) => g),
            minMatchCharLength: 2,
            threshold: 0.15
          },
          matchAllWhenSearchEmpty: !0
        });
        return v.value;
      } else
        return e.data;
    }), b = m(() => f.value.map((v) => v.item || v).sort((v, g) => {
      const y = j(v, o.value), L = j(g, o.value);
      return typeof y == "string" ? u.value === "asc" ? y == null ? void 0 : y.localeCompare(L) : L == null ? void 0 : L.localeCompare(y) : u.value === "asc" ? y - L : L - y;
    }).map(({ _: v, ...g }) => ({
      _: {
        isDisabled: (v == null ? void 0 : v.disabled) ?? !1,
        isSelectable: (v == null ? void 0 : v.seletable) ?? !0,
        isSelected: e.selection.includes(g.id),
        actions: (v == null ? void 0 : v.actions) ?? e.rowActions
      },
      data: g
    }))), w = m(() => b.value.some((v) => v._.isSelectable)), p = m({
      get: () => {
        const v = b.value.filter((g) => g._.isSelectable).length;
        return v >= 1 && v === e.selection.length;
      },
      set: (v) => {
        let g = [];
        v === !0 && (g = b.value.filter((y) => !y._.isDisabled && y._.isSelectable).map((y) => y.data.id)), t("update:selection", g);
      }
    }), _ = (v) => {
      const g = e.selection.includes(v) ? e.selection.slice().filter((y) => v !== y) : e.selection.concat(v);
      t("update:selection", g);
    }, S = (v) => {
      o.value === v ? u.value = u.value === "asc" ? "desc" : "asc" : (o.value = v, u.value = "asc");
    };
    return (v, g) => (l(), s("div", Qe, [
      e.title || e.description || e.searchable || q(n).header ? (l(), k(Ee, {
        key: 0,
        search: i.value,
        "onUpdate:search": g[0] || (g[0] = (y) => i.value = y),
        title: e.title,
        description: e.description,
        searchable: e.searchable
      }, {
        default: $(() => [
          h(v.$slots, "header")
        ]),
        _: 3
      }, 8, ["search", "title", "description", "searchable"])) : c("", !0),
      r("div", Ye, [
        r("table", null, [
          r("colgroup", null, [
            e.selectable ? (l(), s("col", et)) : c("", !0),
            (l(!0), s(C, null, B(e.columns, (y) => (l(), s("col", {
              key: y.key,
              style: Y({ "--w": y.width })
            }, null, 4))), 128)),
            e.rowActions ? (l(), s("col", tt)) : c("", !0)
          ]),
          r("thead", null, [
            r("tr", null, [
              e.selectable ? (l(), s("th", lt, [
                F(r("input", {
                  "onUpdate:modelValue": g[1] || (g[1] = (y) => p.value = y),
                  type: "checkbox",
                  disabled: !w.value
                }, null, 8, st), [
                  [E, p.value]
                ])
              ])) : c("", !0),
              (l(!0), s(C, null, B(e.columns, (y) => (l(), s("th", {
                key: y.key
              }, [
                e.sortable ? (l(), s("button", {
                  key: 0,
                  onClick: (L) => S(y.key)
                }, d(y.label), 9, ot)) : (l(), s("div", nt, d(y.label), 1))
              ]))), 128)),
              e.rowActions ? (l(), s("th", at)) : c("", !0)
            ])
          ]),
          r("tbody", null, [
            (l(!0), s(C, null, B(b.value, (y) => (l(), k(Je, {
              key: y.data.id,
              data: y,
              columns: e.columns,
              "include-checkbox": e.selectable,
              "force-menu": e.forceRowMenu,
              onToggle: (L) => _(y.data.id),
              onAction: g[2] || (g[2] = (L) => t("row-action", L))
            }, {
              default: $(() => [
                h(v.$slots, "row", {
                  data: y.data
                })
              ]),
              _: 2
            }, 1032, ["data", "columns", "include-checkbox", "force-menu", "onToggle"]))), 128))
          ])
        ])
      ])
    ]));
  }
};
const rt = { class: "cf-sidebar-nav" }, ut = /* @__PURE__ */ r("hr", null, null, -1), it = /* @__PURE__ */ r("figure", null, null, -1), dt = /* @__PURE__ */ r("span", null, null, -1), ct = [
  it,
  dt
], _t = {
  __name: "Sidebar",
  setup(a) {
    const t = V(!1), e = m(() => ({
      "cf-sidebar": !0,
      "cf-sidebar--toggled": t.value
    }));
    return (n, o) => (l(), s("aside", {
      class: x(e.value)
    }, [
      r("div", null, [
        r("nav", rt, [
          h(n.$slots, "default"),
          ut
        ]),
        r("button", {
          class: "cf-sidebar-toggle",
          onClick: o[0] || (o[0] = (u) => t.value = !t.value)
        }, ct)
      ])
    ], 2));
  }
};
const Rl = {
  __name: "AppLayout",
  setup(a) {
    return Z(() => {
      document.body.dataset.layout = "app";
    }), (t, e) => (l(), s(C, null, [
      N(ie, null, {
        left: $(() => [
          h(t.$slots, "brand")
        ]),
        right: $(() => [
          h(t.$slots, "navigation")
        ]),
        _: 3
      }),
      N(_t, null, {
        default: $(() => [
          h(t.$slots, "sidebar")
        ]),
        _: 3
      }),
      r("main", null, [
        h(t.$slots, "main")
      ])
    ], 64));
  }
};
const pt = ["onKeydown"], ft = { class: "cf-dialog-header" }, vt = { class: "cf-dialog__title" }, mt = { key: 0 }, ht = { class: "cf-dialog-body" }, bt = { class: "cf-dialog-footer" }, yt = ["disabled"], gt = /* @__PURE__ */ r("svg", {
  xmlns: "http://www.w3.org/2000/svg",
  viewBox: "0 0 16 16",
  width: "16",
  height: "16"
}, [
  /* @__PURE__ */ r("path", { d: "M14.34 13.605L8.696 8.023l5.582-5.645-.71-.703-5.583 5.644L2.34 1.737l-.703.711L7.282 8.03 1.7 13.675l.71.703 5.583-5.645 5.644 5.583.703-.711z" })
], -1), $t = [
  gt
], jl = {
  __name: "Dialog",
  props: {
    title: String,
    description: String,
    persist: {
      type: Boolean,
      default: !1
    },
    persistent: {
      type: Boolean,
      default: !1
    }
  },
  emits: ["close"],
  setup(a, { emit: t }) {
    const e = a, n = V(), o = () => {
      !e.persist && !e.persistent && t("close");
    };
    return Z(() => n.value.showModal()), (u, i) => (l(), s("dialog", {
      class: "cf-dialog",
      ref_key: "dialog",
      ref: n,
      onKeydown: R(D(o, ["prevent"]), ["esc"])
    }, [
      r("div", ft, [
        r("div", vt, d(e.title), 1),
        e.description ? (l(), s("div", mt, d(e.description), 1)) : c("", !0)
      ]),
      r("div", ht, [
        h(u.$slots, "body")
      ]),
      r("div", bt, [
        h(u.$slots, "footer")
      ]),
      e.persistent ? c("", !0) : (l(), s("button", {
        key: 0,
        class: "cf-dialog-close",
        disabled: e.persist,
        onClick: o
      }, $t, 8, yt))
    ], 40, pt));
  }
};
const Il = {
  __name: "DropdownItem",
  props: {
    icon: String,
    to: [Object, String],
    large: Boolean
  },
  setup(a) {
    const t = a, e = m(() => t.to ? I : "a"), n = m(() => ({
      "cf-dropdown-item": !0,
      "cf-dropdown-item--large": t.large
    })), o = m(() => {
      var u;
      if (typeof t.to != "string")
        return { route: t.to };
      if ((u = t.to) != null && u.includes("http"))
        return { link: t.to };
      if (t.to)
        return { route: t.to };
    });
    return (u, i) => (l(), k(M(e.value), {
      class: x(n.value),
      to: o.value.route,
      href: o.value.link
    }, {
      default: $(() => [
        h(u.$slots, "default")
      ]),
      _: 3
    }, 8, ["class", "to", "href"]));
  }
};
const kt = { class: "cf-drop-zone" }, St = ["onDrop"], xt = { class: "cf-drop-zone-box__label" }, wt = { class: "cf-drop-zone-box__action" }, Ct = /* @__PURE__ */ r("span", null, "select from device", -1), Vt = ["required"], Bt = {
  key: 0,
  class: "cf-drop-zone-box__helper"
}, At = {
  key: 1,
  class: "cf-drop-zone-list"
}, Lt = /* @__PURE__ */ r("div", { class: "cf-drop-zone-list__header" }, null, -1), Tt = { class: "cf-drop-zone-list__item" }, qt = /* @__PURE__ */ r("svg", {
  xmlns: "http://www.w3.org/2000/svg",
  viewBox: "0 0 16 16",
  width: "12",
  height: "12"
}, [
  /* @__PURE__ */ r("path", { d: "M14.34 13.605L8.696 8.023l5.582-5.645-.71-.703-5.583 5.644L2.34 1.737l-.703.711L7.282 8.03 1.7 13.675l.71.703 5.583-5.645 5.644 5.583.703-.711z" })
], -1), Dt = [
  qt
], Ul = {
  __name: "DropZone",
  props: {
    modelValue: File,
    label: {
      type: String,
      default: "Add your file here."
    },
    max: {
      type: [Number, String],
      default: 0
    },
    accept: String,
    required: Boolean
  },
  emits: ["update:modelValue", "add", "cancel"],
  setup(a, { emit: t }) {
    const e = a, n = V(null), o = m(() => !!(e.required && !e.modelValue)), u = m(() => {
      if (e.modelValue) {
        const _ = (e.modelValue.size / 1048576).toFixed(0), S = (_ / 1e3).toFixed(1);
        return _ < 100 ? `${_} MB` : `${S} GB`;
      } else
        return "0 MB";
    }), i = (p) => {
      const _ = p.target.files[0];
      b(_);
    }, f = (p) => {
      const _ = p.dataTransfer.files[0];
      b(_);
    }, b = (p) => {
      const _ = parseInt(e.max) * 1048576;
      _ && _ < p.size ? (n.value.value = "", alert(`File cannot exceed ${e.max} MB`)) : (t("update:modelValue", p), t("add", p));
    }, w = () => {
      t("update:modelValue", null), t("cancel");
    };
    return (p, _) => (l(), s("div", kt, [
      a.modelValue ? (l(), s("div", At, [
        Lt,
        r("div", Tt, [
          r("div", null, d(e.modelValue.name), 1),
          r("div", null, d(u.value), 1),
          r("button", { onClick: w }, Dt)
        ])
      ])) : (l(), s("div", {
        key: 0,
        class: "cf-drop-zone-box",
        onDrop: D(f, ["prevent"]),
        onDragenter: _[0] || (_[0] = D(() => {
        }, ["prevent"])),
        onDragover: _[1] || (_[1] = D(() => {
        }, ["prevent"])),
        onDragleave: _[2] || (_[2] = D(() => {
        }, ["prevent"]))
      }, [
        r("div", xt, d(e.label), 1),
        r("label", wt, [
          A(" Drag and drop or "),
          Ct,
          r("input", {
            type: "file",
            ref_key: "input",
            ref: n,
            required: o.value,
            onChange: i
          }, null, 40, Vt)
        ]),
        e.max ? (l(), s("div", Bt, " Files larger than " + d(e.max) + " MB cannot be uploaded ", 1)) : c("", !0)
      ], 40, St))
    ]));
  }
};
const Nt = { class: "cf-tag" }, Mt = /* @__PURE__ */ r("svg", {
  xmlns: "http://www.w3.org/2000/svg",
  viewBox: "0 0 16 16",
  width: "16",
  height: "16"
}, [
  /* @__PURE__ */ r("path", { d: "M14.34 13.605L8.696 8.023l5.582-5.645-.71-.703-5.583 5.644L2.34 1.737l-.703.711L7.282 8.03 1.7 13.675l.71.703 5.583-5.645 5.644 5.583.703-.711z" })
], -1), zt = [
  Mt
], Q = {
  __name: "Tag",
  props: {
    removable: {
      type: Boolean,
      default: !0
    }
  },
  emits: ["remove"],
  setup(a, { emit: t }) {
    const e = a;
    return (n, o) => (l(), s("div", Nt, [
      r("span", null, [
        h(n.$slots, "default")
      ]),
      e.removable ? (l(), s("button", {
        key: 0,
        onClick: o[0] || (o[0] = (u) => t("remove"))
      }, zt)) : c("", !0)
    ]));
  }
};
const Ft = { class: "cf-file-picker" }, Ot = {
  key: 0,
  class: "cf-file-picker-label"
}, Rt = {
  key: 1,
  class: "cf-button cf-file-picker-button"
}, jt = ["required"], Hl = {
  __name: "FilePicker",
  props: {
    modelValue: File,
    label: String,
    action: {
      type: String,
      default: "Choose file"
    },
    required: Boolean
  },
  emits: ["update:modelValue", "change"],
  setup(a, { emit: t }) {
    const e = a, n = (u) => {
      t("update:modelValue", u.target.files[0]), t("change", u);
    }, o = () => {
      t("update:modelValue", null);
    };
    return (u, i) => (l(), s("div", Ft, [
      e.label ? (l(), s("div", Ot, d(e.label), 1)) : c("", !0),
      e.modelValue ? (l(), k(Q, {
        key: 2,
        onRemove: o
      }, {
        default: $(() => {
          var f;
          return [
            A(d((f = e.modelValue) == null ? void 0 : f.name), 1)
          ];
        }),
        _: 1
      })) : (l(), s("label", Rt, [
        A(d(e.action) + " ", 1),
        r("input", {
          type: "file",
          onChange: n,
          required: a.required
        }, null, 40, jt)
      ]))
    ]));
  }
};
const It = { class: "cf-header" }, Ut = { key: 0 }, Ht = { key: 1 }, Kt = { key: 0 }, Kl = {
  __name: "Header",
  props: {
    size: {
      type: String,
      default: "h4"
    },
    title: String,
    surtitle: String,
    subtitle: String
  },
  setup(a) {
    const t = a, e = O();
    return (n, o) => (l(), s("div", It, [
      r("div", null, [
        t.surtitle ? (l(), s("p", Ut, d(t.surtitle), 1)) : c("", !0),
        (l(), k(M(t.size), null, {
          default: $(() => [
            A(d(t.title), 1)
          ]),
          _: 1
        })),
        t.subtitle ? (l(), s("p", Ht, d(t.subtitle), 1)) : c("", !0)
      ]),
      q(e).action ? (l(), s("div", Kt, [
        h(n.$slots, "action")
      ])) : c("", !0)
    ]));
  }
};
const Pt = ["value", "max"], Pl = {
  __name: "Progress",
  props: {
    value: {
      type: [Number, String],
      default: 0
    },
    max: {
      type: [Number, String],
      default: 100
    }
  },
  setup(a) {
    const t = a;
    return (e, n) => (l(), s("progress", {
      class: "cf-progress",
      value: t.value,
      max: t.max
    }, d(a.value) + "% ", 9, Pt));
  }
};
const Et = { class: "cf-form-control" }, Zt = { key: 0 }, Gt = { class: "cf-form-control-widget" }, Wt = { key: 0 }, Xt = ["disabled", "required", "title", "autofocus"], Jt = {
  key: 0,
  value: null
}, Qt = ["value", "disabled"], Yt = { key: 1 }, el = { key: 1 }, tl = {
  __name: "Select",
  props: {
    options: Array,
    ...X
  },
  emits: ["update:modelValue", "input"],
  setup(a, { emit: t }) {
    const e = a, n = m({
      get: () => e.modelValue || e.value,
      set: (o) => {
        t("update:modelValue", o), t("input", { data: o });
      }
    });
    return (o, u) => (l(), s("div", Et, [
      e.label ? (l(), s("label", Zt, d(e.label), 1)) : c("", !0),
      r("div", Gt, [
        e.prefix ? (l(), s("div", Wt, d(e.prefix), 1)) : c("", !0),
        F(r("select", {
          "onUpdate:modelValue": u[0] || (u[0] = (i) => n.value = i),
          disabled: e.disabled,
          required: e.required,
          title: e.title,
          autofocus: e.autofocus
        }, [
          !e.required && e.options.length ? (l(), s("option", Jt)) : c("", !0),
          (l(!0), s(C, null, B(e.options, (i) => (l(), s("option", {
            key: i.value || i,
            value: i.value || i,
            disabled: i.disabled ?? !1
          }, d(i.label || i), 9, Qt))), 128)),
          h(o.$slots, "default")
        ], 8, Xt), [
          [ee, n.value]
        ]),
        e.suffix ? (l(), s("div", Yt, d(e.suffix), 1)) : c("", !0)
      ]),
      e.helper ? (l(), s("small", el, d(e.helper), 1)) : c("", !0)
    ]));
  }
};
const ll = { key: 0 }, sl = { key: 0 }, ol = /* @__PURE__ */ r("figure", null, null, -1), nl = { class: "cf-sidebar-link-children" }, El = {
  __name: "SidebarLink",
  props: {
    to: [String, Object],
    href: String,
    label: String,
    icon: {
      type: Boolean,
      default: !0
    },
    path: String
  },
  setup(a) {
    const t = a, e = m(() => t.path ? le().path.includes(t.path) : null), n = m(() => t.to ? I : "a"), o = m(() => ({
      "cf-sidebar-link": !0,
      [`cf-sidebar-link--${t.label.toLowerCase().replaceAll(" ", "-")}`]: t.icon
    }));
    return (u, i) => t.path ? (l(), s("div", {
      key: 1,
      class: x(["cf-sidebar-link-group", { hasRouterLinkActive: e.value }])
    }, [
      r("button", {
        class: x(o.value)
      }, [
        ol,
        r("span", null, d(t.label), 1)
      ], 2),
      r("div", nl, [
        h(u.$slots, "children")
      ])
    ], 2)) : (l(), s("button", ll, [
      (l(), k(M(n.value), {
        class: x(o.value),
        to: t.to,
        href: t.href
      }, {
        default: $(() => [
          t.icon ? (l(), s("figure", sl)) : c("", !0),
          r("span", null, d(t.label), 1)
        ]),
        _: 1
      }, 8, ["class", "to", "href"]))
    ]));
  }
};
const al = {}, rl = { class: "cf-spinner" }, ul = /* @__PURE__ */ r("div", null, null, -1), il = /* @__PURE__ */ r("div", null, null, -1), dl = /* @__PURE__ */ r("div", null, null, -1), cl = /* @__PURE__ */ r("div", null, null, -1), _l = [
  ul,
  il,
  dl,
  cl
];
function pl(a, t) {
  return l(), s("div", rl, _l);
}
const Zl = /* @__PURE__ */ G(al, [["render", pl]]);
const fl = { class: "cf-summary-list" }, Gl = {
  __name: "SummaryList",
  props: {
    data: {
      type: Array,
      default: () => []
    }
  },
  setup(a) {
    const t = a;
    return (e, n) => (l(), s("dl", fl, [
      (l(!0), s(C, null, B(t.data, (o) => (l(), s(C, null, [
        r("dt", null, d(o.label), 1),
        r("dd", null, d(o.value), 1)
      ], 64))), 256))
    ]));
  }
};
const vl = { class: "cf-switch" }, ml = ["value", "true-value", "false-value", "disabled"], hl = {
  key: 0,
  class: "cf-switch__label"
}, Wl = {
  __name: "Switch",
  props: {
    modelValue: [Number, String, Boolean],
    label: String,
    value: [Number, String, Boolean],
    trueValue: {
      type: [Number, String, Boolean],
      default: !0
    },
    falseValue: {
      type: [Number, String, Boolean],
      default: !1
    },
    disabled: Boolean
  },
  emits: ["update:modelValue"],
  setup(a, { emit: t }) {
    const e = a, n = m({
      get() {
        return e.modelValue;
      },
      set(o) {
        t("update:modelValue", o);
      }
    });
    return (o, u) => (l(), s("div", vl, [
      F(r("input", {
        class: "cf-switch__box",
        "onUpdate:modelValue": u[0] || (u[0] = (i) => n.value = i),
        type: "checkbox",
        value: e.value,
        "true-value": e.trueValue,
        "false-value": e.falseValue,
        disabled: e.disabled
      }, null, 8, ml), [
        [E, n.value]
      ]),
      e.label ? (l(), s("div", hl, d(e.label), 1)) : c("", !0)
    ]));
  }
};
const bl = { class: "cf-navigation-tabs" }, Xl = {
  __name: "TabNavigation",
  props: {
    tabs: Array
  },
  setup(a) {
    const t = a;
    return (e, n) => {
      const o = z("router-link");
      return l(), s("nav", bl, [
        r("ul", null, [
          (l(!0), s(C, null, B(t.tabs, (u, i) => (l(), s("li", { key: i }, [
            N(o, {
              to: u.to
            }, {
              default: $(() => [
                A(d(u.label), 1)
              ]),
              _: 2
            }, 1032, ["to"])
          ]))), 128))
        ])
      ]);
    };
  }
};
const yl = ["inert"], gl = { key: 0 }, $l = { class: "cf-tags-field__input" }, kl = ["required"], Sl = { class: "cf-tags-field__tags" }, xl = { key: 1 }, Jl = {
  __name: "TagsField",
  props: {
    modelValue: Array,
    label: String,
    buttonText: {
      type: String,
      default: "Add"
    },
    prefix: String,
    options: Array,
    helper: String,
    disabled: Boolean,
    required: Boolean
  },
  emits: ["update:modelValue"],
  setup(a, { emit: t }) {
    const e = a, n = V(!1), o = V(""), u = m(() => {
      var p;
      return (p = e.options) == null ? void 0 : p.map((_) => ({
        label: _.label || _,
        value: _.value || _
      }));
    }), i = m(() => {
      var p;
      return (p = u.value) == null ? void 0 : p.filter(
        (_) => !e.modelValue.includes(_.value)
      );
    }), f = (p) => u.value.find((_) => _.value === p).label, b = () => {
      if (!o.value || e.disabled)
        return !1;
      const p = e.modelValue;
      p.push(o.value), t("update:modelValue", p), o.value = "", n.value = !1;
    }, w = (p) => {
      if (e.disabled)
        return !1;
      const _ = e.modelValue;
      _.splice(p, 1), t("update:modelValue", _);
    };
    return (p, _) => (l(), s("div", {
      class: "cf-tags-field",
      inert: e.disabled
    }, [
      e.label ? (l(), s("label", gl, d(e.label), 1)) : c("", !0),
      r("div", $l, [
        !e.options && n.value ? (l(), k(J, {
          key: 0,
          modelValue: o.value,
          "onUpdate:modelValue": _[0] || (_[0] = (S) => o.value = S),
          prefix: e.prefix,
          onKeydown: R(b, ["enter"]),
          onChange: b,
          required: ""
        }, null, 8, ["modelValue", "prefix", "onKeydown"])) : c("", !0),
        e.options && n.value ? (l(), k(tl, {
          key: 1,
          modelValue: o.value,
          "onUpdate:modelValue": _[1] || (_[1] = (S) => o.value = S),
          options: i.value,
          onKeydown: R(b, ["enter"]),
          onChange: b,
          required: ""
        }, null, 8, ["modelValue", "options", "onKeydown"])) : c("", !0),
        n.value ? c("", !0) : (l(), k(Ce, {
          key: 2,
          color: "blue",
          onClick: _[2] || (_[2] = (S) => n.value = !0)
        }, {
          default: $(() => [
            A(d(e.buttonText), 1)
          ]),
          _: 1
        })),
        r("input", {
          class: "cf-tags-field__input__faux",
          type: "text",
          required: e.required && !e.modelValue.length
        }, null, 8, kl)
      ]),
      r("div", Sl, [
        (l(!0), s(C, null, B(e.modelValue, (S, v) => (l(), k(Q, {
          key: S,
          onRemove: (g) => w(v)
        }, {
          default: $(() => [
            A(d(e.prefix) + " " + d(e.options ? f(S) : S), 1)
          ]),
          _: 2
        }, 1032, ["onRemove"]))), 128))
      ]),
      e.helper ? (l(), s("small", xl, d(e.helper), 1)) : c("", !0)
    ], 8, yl));
  }
};
export {
  Al as CfActionCard,
  ie as CfAppBar,
  Ll as CfAppBarLink,
  Rl as CfAppLayout,
  Tl as CfAppView,
  ql as CfAppViewHeader,
  Dl as CfBanner,
  Nl as CfBreadcrumbs,
  qe as CfChoice,
  Fl as CfChoiceList,
  Ol as CfDataTable,
  jl as CfDialog,
  Ul as CfDropZone,
  ce as CfDropdown,
  Il as CfDropdownItem,
  Hl as CfFilePicker,
  Ml as CfFilledButton,
  Kl as CfHeader,
  J as CfInput,
  Ce as CfOutlinedButton,
  Pl as CfProgress,
  tl as CfSelect,
  _t as CfSidebar,
  El as CfSidebarLink,
  Zl as CfSpinner,
  Gl as CfSummaryList,
  Wl as CfSwitch,
  Xl as CfTabNavigation,
  Q as CfTag,
  Jl as CfTagsField,
  zl as CfTextButton
};
